import * as React from 'react';

import { IgrDataGridModule } from 'igniteui-react-grids';
import { IgrDataGrid } from 'igniteui-react-grids';

IgrDataGridModule.register();

export default class DataGridOverview extends React.Component<any, any> {

    public data: any[];
    public grid: IgrDataGrid;

    private count: number = 0;

    constructor(props: any) {
        super(props);

        this.data = [
            { ID: 1, FamilyName: "田沢", GivenName: "泰三", Prefecture: "新潟県", City: "新潟市西蒲区" },
            { ID: 2, FamilyName: "玉木", GivenName: "裕美子", Prefecture: "宮城県", City: "登米市" },
            { ID: 3, FamilyName: "稲垣", GivenName: "幸男", Prefecture: "鳥取県", City: "八頭郡八頭町" },
            { ID: 4, FamilyName: "石橋", GivenName: "幸春", Prefecture: "福井県", City: "越前市" },
            { ID: 5, FamilyName: "小柳", GivenName: "穂香", Prefecture: "大分県", City: "豊後大野市" },
        ];

        this.onGridRef = this.onGridRef.bind(this);
        this.buttonClicked1 = this.buttonClicked1.bind(this);
    }

    public render(): JSX.Element {
        return (
            <div style={{margin: "1em"}}>
                <IgrDataGrid
                    ref={this.onGridRef}
                    height="300px"
                    width="100%"
                    autoGenerateColumns="true"
                    dataSource={this.data}
                    selectionMode="SingleRow">
               </IgrDataGrid>
               <button onClick={this.buttonClicked1}>Select</button>
            </div>
        );
    }

    public onGridRef(grid: IgrDataGrid) {
        if (!grid) { return; }

        this.grid = grid;
    }

    public buttonClicked1() {
        // 1行だけ選択したい場合はselectedItemsをクリアしておく（※複数行選択したい場合はこのコードは不要です）。
        this.grid.selectedItems.clear();
        // 0行目を選択する。
        this.grid.selectedItems.add(this.data[this.count++]);
        if(this.count >= this.data.length){
            this.count = 0;
        }
    }
}
